import updateKeys from './lib/updateKeys';

export default function decryptChunk(encryptedChunk: Buffer, [key0, key1, key2]: [number, number, number]): {decryptedChunk: Buffer, keys: [number, number, number]} {
  const decryptedChunk = Buffer.alloc(encryptedChunk.length);
  const dvOut = new DataView(decryptedChunk.buffer);

  for (let i = 0; i < encryptedChunk.length; i += 1) {
    //read and decrypt byte
    let curChar = encryptedChunk.readUInt8(i);
    const keyPart = (key2 | 2) & 0xFFFF;
    const decryptedByte = (keyPart * (keyPart ^ 1)) >>> 8;
    curChar ^= decryptedByte & 0xFF;
    dvOut.setUint8(i, curChar);

    //update keys
    [key0, key1, key2] = updateKeys([key0, key1, key2], curChar);
  }

  return { decryptedChunk, keys: [key0, key1, key2] };
}
